﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace SilverlightApplication2
{
	public partial class MainPage : UserControl
	{
		Dictionary<RadTileViewItem, RadFluidContentControl> fluidControls = new Dictionary<RadTileViewItem, RadFluidContentControl>();

		public MainPage()
		{
			InitializeComponent();
			this.tileView1.ItemsSource = new DataItems();

			this.Dispatcher.BeginInvoke(() =>
			{
				for (int i = 0; i < this.tileView1.Items.Count; i++)
				{
					RadTileViewItem tileViewItem = this.tileView1.ItemContainerGenerator.ContainerFromIndex(i) as RadTileViewItem;
					RadFluidContentControl fluidControl = tileViewItem.FindChildByType<RadFluidContentControl>();
					fluidControl.State = FluidContentControlState.Normal;
					this.fluidControls.Add(tileViewItem, fluidControl);
				}
			});
		}

		private void tileView1_TileStateChanged(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			RadTileViewItem tileViewItem = e.OriginalSource as RadTileViewItem;
			RadFluidContentControl fluidControl = this.fluidControls[tileViewItem];
			switch (tileViewItem.TileState)
			{
				case TileViewItemState.Maximized:
					fluidControl.State = FluidContentControlState.Large;
					break;
				case TileViewItemState.Minimized:
					fluidControl.State = FluidContentControlState.Small;
					break;
				case TileViewItemState.Restored:
					fluidControl.State = FluidContentControlState.Normal;
					break;
			}
		}
	}

	public class DataItems : List<DataItem>
	{
		public DataItems()
		{
			for (int i = 0; i < 5; i++)
			{
				DataItem d = new DataItem();
				d.Header = string.Format("Item {0}", i);
				d.MySmallContent = string.Format("Item {0} Small Content", i);
				d.MyNormalContent = string.Format("Item {0} Normal Content", i);
				d.MyLargeContent = string.Format("Item {0} Large Content", i);
				this.Add(d);
			}
		}
	}

	public class DataItem
	{
		public string Header { get; set; }
		public object MySmallContent { get; set; }
		public object MyNormalContent { get; set; }
		public object MyLargeContent { get; set; }
	}
}
